import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Shooter here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Shooter  extends Automaton
{
    public void runRules() {
        Automaton left = getAutomatonLeft();
        Automaton right = getAutomatonRight();
        World world = getWorld();
        
        if(this.getState() == State.FIRE) {
            setState(State.NONE);
            RuleHighlighter.addToWorld(225, 20, world);
        } else if(this.getState() == State.COUNTING_DOWN && getParameter() == 0) {
            setState(State.FIRE);
            RuleHighlighter.addToWorld(243, 18, world);
        } else if(this.getState() == State.COUNTING_UP && right == null) {
            setState(State.COUNTING_DOWN);
            RuleHighlighter.addToWorld(261, 39, world);
        } else if(this.getState() == State.COUNTING_DOWN) {
            int param = getParameter();
            setParameter(param-1);
            RuleHighlighter.addToWorld(300, 18, world);
        } else if(right != null && right.getState() == State.COUNTING_DOWN) {
            setState(State.COUNTING_DOWN);
            int param = right.getParameter();
            setParameter(param-1);
            RuleHighlighter.addToWorld(318, 36, world);
        } else if(this.getState() == State.COUNTING_UP) {
            // No changes - wait for COUNTING_DOWN from right
            RuleHighlighter.addToWorld(354, 18, world);
        } else if(left != null && left.getState() == State.COUNTING_UP) {
            setState(State.COUNTING_UP);
            int param = left.getParameter();
            setParameter(param+1);
            RuleHighlighter.addToWorld(372, 36, world);
        } else if(left != null && left.getState() == State.COMMAND_TO_FIRE) {
            setState(State.COUNTING_UP);
            RuleHighlighter.addToWorld(408, 36, world);
        }
    }
}
